//+------------------------------------------------------------------+
//|                                                 exp_Kevin_V0.mq4 |
//|                                            yuriytokman@gmail.com |
//|    //mod nituser                           yuriytokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "yuriytokman@gmail.com"
#property link      "yuriytokman@gmail.com"
//Mr tokman sorry for my lateness as I had urgent business to handle.I have a slight change 
//in plans.Indicator change instead of Bykov please use no repaint ADX as I will attach it.
//Here is simple rules.
//1) EA must open a buy position when blue arrow /sell position when red arrow...and take only
// one position per signal.
//2)EA must have a long or short /long and short function in common section this is if I want 
//it to take buys only or shorts only
//3)stop loss and take profit but they must open seperately(milliseconds apart) ECN broker
//require this so two  commands instead of one
//4)stop loss and take profit....simple...
//kevin

//1) . .   ,     /  ,  
//  ...       .
//2) .      /        , 
//         
//3) Stop Loss  Take Profit,       ( ) ECN 
//       
//4) Stop Loss  Take Profit ....  ...,       
//,      , ,  .
//Kevin 
// mod to autodetect cross direction niteuser

extern string __1_______              = "Adjustments of the indicator ADXcrosses";
extern int    TimeFrame               = 0;//Symbol the data of which should be used to calculate indicator. NULL means current symbol.
extern int    shift                   = 0;//Index of the value taken from the indicator buffer (shift relative to the current bar the given amount of periods ago).
extern int    ADXcrossesPeriod        = 28;//Averaging period for calculation.

extern string _____2_____             = "Adjustments of the adviser";
extern bool   buys_only               = false;// buys only
extern bool   shorts_only             = false;// shorts only
extern int    StopLoss                = 50;//Stop loss level.
extern int    TakeProfit              = 10;//Take profit level.
extern int    MagicNumber             = 2851;//Order magic number. May be used as user defined identifier.
extern int    Slippage                = 3;//Maximum price slippage for buy or sell orders.
extern int    NumberOfTry             = 5;//Quantity of trade attempts
extern double Lots                    = 0.01;//Number of lots.
extern bool   MarketWatch             = true;//Inquiries under execution " Market Watch ".

extern string _____3_____             = "Other adjustments";
extern bool   UseSound                = True;//To use a sound signal
extern string NameFileSound           = "expert.wav";//The name of a sound file
extern color  clOpenBuy               = LightBlue;//Colour of a badge of opening of purchase
extern color  clOpenSell              = LightCoral;//Colour of a badge of opening of sale
extern bool   ShowComment             = true;//To show the comment

//-------    -------------------------------------+
int           NumberAccount         = 0;             //   
bool          gbDisabled            = False;         //   
bool          gbNoInit              = False;         //   

#include      <stdlib.mqh>                      //   4


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  gbNoInit=False;
  if (!IsTradeAllowed()) {
    Message("For normal job of the adviser it is necessary\n"+
            "To permit to the adviser to trade");
    gbNoInit=True; return;
  }
  if (!IsLibrariesAllowed()) {
    Message("For normal job of the adviser it is necessary\n"+
            "To permit import from the external experts");
    gbNoInit=True; return;
  }
  if (!IsTesting()) {
    if (IsExpertEnabled()) Message("The adviser will be started by the following ticks");
    else Message("The button is switched off \"To permit start of the advisers\"");
  }   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  if (!IsTesting()) Comment("");    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if (gbDisabled) {
    Message("Critical mistake! The adviser IS STOPPED!"); return;
  }
  if (gbNoInit) {
    Message("The adviser was not possible to initialize!"); return;
  }
  if (!IsTesting()) {
    if (NumberAccount>0 && NumberAccount!=AccountNumber()) {
      Comment("Trade on the bill: "+AccountNumber()+" IS FORBIDDEN!");
      return;
    } else Comment("");}
//----
//---
    string st="CurTime="+TimeToStr(TimeCurrent(), TIME_MINUTES)
               +"  TakeProfit="+TakeProfit
               +"  StopLoss="+StopLoss
               +"  Lots="+DoubleToStr(Lots,2)
               //+IIFs(Trailing,"    !", "")
               +"  SPREAD="+DoubleToStr(MarketInfo(Symbol(),MODE_SPREAD),2)                                                                         
               ;
    if (ShowComment) {
     string st2="\n\n AccountBalance="+DoubleToStr(AccountBalance(), 2)
               +"\n AccountEquity="+DoubleToStr(AccountEquity(), 2)
               +"\n Profit="+DoubleToStr(AccountEquity()-AccountBalance(),3)+" $"
               +"\n Profit="+DoubleToStr((AccountEquity()/AccountBalance()-1)*100,3)+" %"
               ;
    } else st2="";
    Comment(st+st2);
//----
   
//----
//----  
 double sl=0, tp=0;
   if(!ExistPositions(Symbol(),OP_BUY,MagicNumber) && GetsSignal()==1 && buys_only)
    { 
     if (StopLoss  >0) sl=Ask-StopLoss*Point;   else sl=0;
     if (TakeProfit>0) tp=Ask+TakeProfit*Point; else tp=0;
     OpenPosition(NULL, OP_BUY, Lots, sl, tp, MagicNumber);
    }
       
   if(!ExistPositions(Symbol(),OP_SELL,MagicNumber) && GetsSignal()==-1 && shorts_only)
    {
     if (StopLoss  >0) sl=Bid+StopLoss*Point;   else sl=0;
     if (TakeProfit>0) tp=Bid-TakeProfit*Point; else tp=0;
     OpenPosition(NULL, OP_SELL, Lots, sl, tp, MagicNumber);
    }    
//----
   return(0);
  }
//+----------------------------------------------------------------------------+
//|      :   ,  yuriytokman@gmail.com                          |
//+----------------------------------------------------------------------------+
//|   :                                       |
//+----------------------------------------------------------------------------+
 int GetsSignal()
   {    
    double i_0 = iCustom(Symbol(),TimeFrame,"ADXcrossesNon-repainting",ADXcrossesPeriod,0,shift);
    double i_1 = iCustom(Symbol(),TimeFrame,"ADXcrossesNon-repainting",ADXcrossesPeriod,1,shift);        
    double way = iCustom(NULL, 0, "Nina",7,0.7,0,500,4,0); // detect longs or shorts only
    if(way == 1) { buys_only = True; shorts_only = False; Print("Buy");} 
    if(way == 2) { buys_only = False; shorts_only = True; Print("Sell"); }
    //if(way == 0) { buys_only = False; shorts_only = False; }// set all false at start only to wait for cross
    int vSignal = 0;
    
    if(i_0<1000 ) vSignal =+1;  //up
 
    else
   
    if(i_1<1000 ) vSignal = -1; //down
   
    return (vSignal);
   }
//+----------------------------------------------------------------------------+
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;
  string   lsComm=WindowExpertName()+" "+GetNameTF(Period());

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, lsComm, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("UnknownPeriod");
  }
}
//+----------------------------------------------------------------------------+
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}